package com.ashokit.advjpa.service;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ashokit.advjpa.dao.BookDao;
import com.ashokit.advjpa.dao.PersonDao;
import com.ashokit.advjpa.model.Book;
import com.ashokit.advjpa.model.Person;

@Service
public class PersonService {
	
	
	@Autowired
	private PersonDao personDao;
	
	
	@Autowired
	private BookDao bookDao;
	
	
	
	
	public Iterable<Book> findAllBookBybookName(String bookName)
	{
		return bookDao.findAllBookBybookName(bookName);
	}
	
	public Iterable<Book> findByBookName(String bookName){
		return bookDao.findByBookName(bookName);
	}
	
	//SAve All Books
	
	public Iterable<Book> saveAllBooks(Iterable<Book> booksList){
		return bookDao.saveAll(booksList);
	}
	
	public Iterable<Book> getAllBooks(){
		return bookDao.findAll();
	}
	
	//Retrieve Books
	
	
	//SaveAll Implementation
	
	public Iterable<Person> saveAllPersons(Iterable<Person> personsList){
		return personDao.saveAll(personsList);
		
		/*
		 * saveAll ==> Iterate Through each and every object and insert every record
		 */
	}
	
	
	
	
	//FindAllById Implementation

	public Iterable<Person> getPersonsData(List<Integer> personIds){
		return personDao.findAllById(personIds);
	}
	
	public List<Person> findByFirstNameLike(String firstName){
		return personDao.findByFirstNameLike(firstName);
	}
	
	public List<Person> findByLastNameAndAgeLessThanEqual(String lastName,int age){
		return personDao.findByLastNameAndAgeLessThanEqual(lastName, age);
	}
	
	public List<Person> findByAgeLessThanEqual(Integer age){
		return personDao.findByAgeLessThanEqual(age);
	}
	
	public List<Person> findByCreatedDateBetween(Date startdate,Date endDate){
		return personDao.findByCreatedDateBetween(startdate, endDate);
	}
	
	
	
	public Person findByLastNameAndFirstName(String lastName,String firstName) {
		return personDao.findByLastNameAndFirstName(lastName, firstName);
	}
	
	
	public Iterable<Person> findByLastNameOrFirstName(String lastName,String firstName){
		return personDao.findByLastNameOrFirstName(lastName, firstName);
	}
	
	public List<Person> findByLastNameOrderByCreatedDateDesc(String lastName){
		return personDao.findByLastNameOrderByCreatedDateDesc(lastName);
	}
	
	public List<Person> searchpersonbyLastname(String lastName){
		return personDao.searchpersonbyLastname(lastName);
	}
}
